*** applications/aufs/afposenum.c.orig	Thu May 19 12:19:54 1988
--- applications/aufs/afposenum.c	Fri Dec  9 11:13:30 1988
***************
*** 29,34
  #include <sys/time.h>
  #include <netat/appletalk.h>
  #include <netat/afp.h>
  #include "afps.h"
  #include "afpdt.h"
  #include "afpgc.h"

--- 29,35 -----
  #include <sys/time.h>
  #include <netat/appletalk.h>
  #include <netat/afp.h>
+ #include <strings.h>
  #include "afps.h"
  #include "afpdt.h"
  #include "afpgc.h"
***************
*** 57,62
  private void EC_Free();
  private iselect();
  
  /*
   * int iselect(struct direct *d)
   * 

--- 58,68 -----
  private void EC_Free();
  private iselect();
  
+ #ifdef NOCASEMATCH
+ private noCaseDir();
+ private searchDirectory();
+ #endif NOCASEMATCH
+ 
  /*
   * int iselect(struct direct *d)
   * 
***************
*** 426,433
  
  OSfname(r,idir,fn,typ)
  IDirP idir;
! char *fn,*r;
! int typ;
  {
    char *p;
  

--- 432,439 -----
  
  OSfname(r,idir,fn,typ)
  IDirP idir;
! register char *fn,*r;
! register int typ;
  {
    register char *p;
  
***************
*** 429,435
  char *fn,*r;
  int typ;
  {
!   char *p;
  
    for (p = pathstr(idir); *p != '\0';)		/* copy the directory */
      *r++ = *p++;

--- 435,441 -----
  register char *fn,*r;
  register int typ;
  {
!   register char *p;
  
    for (p = pathstr(idir); *p != '\0';)		/* copy the directory */
      *r++ = *p++;
***************
*** 434,442
    for (p = pathstr(idir); *p != '\0';)		/* copy the directory */
      *r++ = *p++;
  
-   if (typ != F_DATA) 
-     *r++ = '/';
- 
    if (typ == F_RSRC || typ == F_FNDR) /* append directory names */
      for (p = ((typ == F_RSRC) ? RFDIRFN : FIDIRFN); *p != '\0'; )
        *r++ = *p++;

--- 440,445 -----
    for (p = pathstr(idir); *p != '\0';)		/* copy the directory */
      *r++ = *p++;
  
    if (typ == F_RSRC || typ == F_FNDR) /* append directory names */
      for (p = ((typ == F_RSRC) ? RFDIR : FIDIR); *p != '\0'; )
        *r++ = *p++;
***************
*** 438,444
      *r++ = '/';
  
    if (typ == F_RSRC || typ == F_FNDR) /* append directory names */
!     for (p = ((typ == F_RSRC) ? RFDIRFN : FIDIRFN); *p != '\0'; )
        *r++ = *p++;
  
    if (*fn != '\0')		/* add slash */

--- 441,447 -----
      *r++ = *p++;
  
    if (typ == F_RSRC || typ == F_FNDR) /* append directory names */
!     for (p = ((typ == F_RSRC) ? RFDIR : FIDIR); *p != '\0'; )
        *r++ = *p++;
  
    if (*fn != '\0') {		/* add slash */
***************
*** 441,447
      for (p = ((typ == F_RSRC) ? RFDIRFN : FIDIRFN); *p != '\0'; )
        *r++ = *p++;
  
!   if (*fn != '\0')		/* add slash */
      *r++ = '/';			/*  if not null file */
    while (*fn != '\0')
      *r++ = *fn++;

--- 444,450 -----
      for (p = ((typ == F_RSRC) ? RFDIR : FIDIR); *p != '\0'; )
        *r++ = *p++;
  
!   if (*fn != '\0') {		/* add slash */
      *r++ = '/';			/*  if not null file */
      while (*fn != '\0')
        *r++ = *fn++;
***************
*** 443,450
  
    if (*fn != '\0')		/* add slash */
      *r++ = '/';			/*  if not null file */
!   while (*fn != '\0')
!     *r++ = *fn++;
    *r = '\0';
  }
    

--- 446,454 -----
  
    if (*fn != '\0') {		/* add slash */
      *r++ = '/';			/*  if not null file */
!     while (*fn != '\0')
!       *r++ = *fn++;
!   }
    *r = '\0';
  }
  
***************
*** 447,452
      *r++ = *fn++;
    *r = '\0';
  }
-   
  
  

--- 451,456 -----
    }
    *r = '\0';
  }
  
  toResFork(str, fn)
  register char *str;
***************
*** 449,452
  }
    
  
  

--- 452,462 -----
    *r = '\0';
  }
  
+ toResFork(str, fn)
+ register char *str;
+ char *fn;
+ {
+   register char *fp, *tp;
  
    if(*fn) {			/* a real file */
      if(fp = rindex(str, '/'))	/* skip over last slash */
***************
*** 450,452
    
  
  

--- 458,617 -----
  {
    register char *fp, *tp;
  
+   if(*fn) {			/* a real file */
+     if(fp = rindex(str, '/'))	/* skip over last slash */
+       fp++;
+     else
+       fp = str;
+     str = fp;
+     fp = str + strlen(str);
+     tp = fp + DIRRFLEN;
+     *tp = 0;
+     while(fp > str)	/* move filename, leaving space for .resource */
+       *--tp = *--fp;
+     fp = DIRRF;
+     while(*fp)
+       *str++ = *fp++;
+   } else			/* a directory */
+     strcat(str,RFDIR);		/* just append .resource */
+ }
+ 
+ toFinderInfo(str, fn)
+ register char *str;
+ char *fn;
+ {
+   register char *fp, *tp;
+ 
+   if(*fn) {			/* a real file */
+     if(fp = rindex(str,'/'))	/* skip over last slash */
+       fp++;
+     else
+       fp = str;
+     str = fp;
+     fp = str + strlen(str);
+     tp = fp + DIRFILEN;
+     *tp = 0;
+     while(fp > str)	/* move filename, leaving space for .finderinfo */
+       *--tp = *--fp;
+     fp = DIRFI;
+     while(*fp)
+       *str++ = *fp++;
+   } else			/* a directory */
+     strcat(str,FIDIR);		/* just append .finderinfo */
+ }
+ 
+ #ifdef NOCASEMATCH
+ #include <sys/file.h>
+ #include <ctype.h>
+ 
+ /*
+  * searchDirectory(dir, name)
+  *	Do a case insensitive search for name in dir, and write the true name
+  *	of the file in name.
+  */
+ 
+ private
+ searchDirectory(dir, name)
+ char *dir, *name;
+ {
+ 	register char *fp, *tp;
+ 	register DIR *dp;
+ 	register struct direct *d;
+ 	register int len;
+ 	char lname[BUFSIZ], dname[BUFSIZ];
+ 
+ 	if((dp = opendir(dir)) == NULL)
+ 		return(0);
+ 	len = 0;
+ 	for(fp = name, tp = lname ; *fp ; fp++) {
+ 		*tp++ = isupper(*fp) ? tolower(*fp) : *fp;
+ 		len++;
+ 	}
+ 	*tp = 0;
+ 	while(d = readdir(dp)) {
+ 		if(d->d_namlen != len)
+ 			continue;
+ 		for(fp = d->d_name, tp = dname ; *fp ; fp++)
+ 			*tp++ = isupper(*fp) ? tolower(*fp) : *fp;
+ 		*tp = 0;
+ 		if(strcmp(dname, lname) == 0) {
+ 			strcpy(name, d->d_name);
+ 			closedir(dp);
+ 			return(1);
+ 		}
+ 	}
+ 	closedir(dp);
+ 	return(0);
+ }
+ 
+ /*
+  * noCaseDir(path)
+  *	Recursively verify the components of path.
+  */
+ 
+ private
+ noCaseDir(path)
+ register char *path;
+ {
+ 	register char *last;
+ 	register int status;
+ 
+ 	if(access(path, F_OK) >= 0)
+ 		return(1);
+ 	if(last = rindex(path, '/')) {
+ 		if(last == path)
+ 			return(searchDirectory("/", last + 1));
+ 		else {
+ 			*last++ = 0;
+ 			status = 0;
+ 			if(noCaseDir(path))
+ 				status = searchDirectory(path, last);
+ 			*--last = '/';
+ 			return(status);
+ 		}
+ 	}
+ 	return(searchDirectory(".", path));
+ }
+ 
+ /*
+  * noCaseFind(path)
+  *	noCaseFind() calls noCaseDir() and searchDirectory() recursively to
+  *	take path (case insensitive) and converts it to (case sensitive) newpath
+  *	corresponding to the true Unix filename.  This is mainly to fix
+  *	HyperCard doing funny things to stack names.
+  */
+ 
+ void
+ noCaseFind(path)
+ register char *path;
+ {
+ 	register char *last;
+ 
+ 	if(last = rindex(path, '/')) {
+ 		if(last == path)
+ 			searchDirectory("/", last + 1);
+ 		else {
+ 			*last++ = 0;
+ 			if(noCaseDir(path))
+ 				searchDirectory(path, last);
+ 			*--last = '/';
+ 		}
+ 	} else
+ 		searchDirectory(".", path);
+ }
+ 
+ /*
+  * noCaseMatch(path)
+  *	noCaseMatch() tests path first and will call noCaseFind() is path
+  *	doesn't exist.
+  */
+ 
+ void
+ noCaseMatch(path)
+ register char *path;
+ {
+ 	if(access(path, F_OK) >= 0)
+ 		return;
+ 	noCaseFind(path);
+ }
+ #endif NOCASEMATCH
